#Debug
#say update

#Execute init code on new players
tag @r[type=player,c=1000000] add allowed
kick @a[tag=!allowed] There are too many players on this world.
tag @a remove allowed

scoreboard objectives add init dummy
scoreboard players operation @a started = world started
scoreboard players operation @a init = world init
scoreboard players operation @a time = world time
scoreboard players operation @a season = world season
scoreboard players operation @a weather = world weather
scoreboard players operation @a sidebar = world sidebar
execute as @a[tag=!firstjoin] at @s run function TaB/firstjoin

#Disable sending feedback to users
gamerule sendcommandfeedback true
#Write update code here

execute as @e[type=player,tag=!sync] at @s run summon tl:player
execute as @a at @s if block ~~1~ air 0 run scoreboard players set @s[scores={watercontact=4}] watercontact 3
tag @e[type=player] remove sync
tag @e[type=tl:player] remove sync
execute as @e[type=tl:player] at @s run tag @p[r=1] add sync
execute as @e[type=player,tag=sync] at @s run tag @e[type=tl:player,r=1,c=1] add sync
execute as @e[type=player] at @s positioned ~-0.1~~ run tp @e[type=tl:player,r=1,tag=sync] @s
tag @e[type=tl:player,tag=!sync] add kill

replaceitem entity @a[hasitem={location=slot.weapon.mainhand,item=potion,data=0}] slot.weapon.mainhand 0 tl:water_bottle
replaceitem entity @a[hasitem={location=slot.weapon.mainhand,item=milk_bucket,data=0}] slot.weapon.mainhand 0 tl:milk_bucket

execute as @r[type=player,c=1000000,tag=dead] at @s run function TaB/death
tag @a add dead
tag @r[type=player,c=1000000] remove dead

execute as @e[type=item] at @s if block ~~~ lava -1 run tp @s ~~0.15~
#execute as @e[type=item] at @s if block ~~~ flowing_lava -1 run tp @s ~~0.15~

execute as @a[hasitem={item=tl:volcano_helmet,location=slot.armor.head}] as @s[hasitem={item=tl:volcano_chestplate,location=slot.armor.chest}] as @s[hasitem={item=tl:volcano_leggings,location=slot.armor.legs}] as @s[hasitem={item=tl:volcano_boots,location=slot.armor.feet}] run scoreboard players set @s[scores={fire_resistance=..2}] fire_resistance 3
execute as @a[hasitem={item=tl:winter_helmet,location=slot.armor.head}] as @s[hasitem={item=tl:winter_chestplate,location=slot.armor.chest}] as @s[hasitem={item=tl:winter_leggings,location=slot.armor.legs}] as @s[hasitem={item=tl:winter_boots,location=slot.armor.feet}] run scoreboard players set @s[scores={ice_resistance=..2}] ice_resistance 3
scoreboard players remove @a[scores={tick=20..,climate_clemency=2..}] climate_clemency 1
scoreboard players set @a[scores={climate_clemency=..1}] climate_clemency 1
scoreboard players remove @a[scores={tick=20..,heat_clemency=2..}] heat_clemency 1
scoreboard players set @a[scores={heat_clemency=..1}] heat_clemency 1
scoreboard players remove @a[scores={tick=20..,cold_clemency=2..}] cold_clemency 1
scoreboard players set @a[scores={cold_clemency=..1}] cold_clemency 1

titleraw @a[scores={climate_clemency=60}] actionbar {"rawtext": [{"text": "Still immune to temperature for: "}, {"score":{"name": "*","objective": "climate_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={climate_clemency=45}] actionbar {"rawtext": [{"text": "Still immune to temperature for: "}, {"score":{"name": "*","objective": "climate_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={climate_clemency=30}] actionbar {"rawtext": [{"text": "Still immune to temperature for: "}, {"score":{"name": "*","objective": "climate_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={climate_clemency=10}] actionbar {"rawtext": [{"text": "Still immune to temperature for: "}, {"score":{"name": "*","objective": "climate_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={climate_clemency=6}] actionbar {"rawtext": [{"text": "Still immune to temperature for: 5 seconds"}]}
titleraw @a[scores={climate_clemency=5}] actionbar {"rawtext": [{"text": "Still immune to temperature for: 4 seconds"}]}
titleraw @a[scores={climate_clemency=4}] actionbar {"rawtext": [{"text": "Still immune to temperature for: 3 seconds"}]}
titleraw @a[scores={climate_clemency=3}] actionbar {"rawtext": [{"text": "Still immune to temperature for: 2 seconds"}]}
titleraw @a[scores={climate_clemency=2}] actionbar {"rawtext": [{"text": "Still immune to temperature for: 1 seconds"}]}
titleraw @a[scores={heat_clemency=60}] actionbar {"rawtext": [{"text": "Still immune to heat for: "}, {"score":{"name": "*","objective": "heat_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={heat_clemency=45}] actionbar {"rawtext": [{"text": "Still immune to heat for: "}, {"score":{"name": "*","objective": "heat_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={heat_clemency=30}] actionbar {"rawtext": [{"text": "Still immune to heat for: "}, {"score":{"name": "*","objective": "heat_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={heat_clemency=10}] actionbar {"rawtext": [{"text": "Still immune to heat for: "}, {"score":{"name": "*","objective": "heat_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={heat_clemency=6}] actionbar {"rawtext": [{"text": "Still immune to heat for: 5 seconds"}]}
titleraw @a[scores={heat_clemency=5}] actionbar {"rawtext": [{"text": "Still immune to heat for: 4 seconds"}]}
titleraw @a[scores={heat_clemency=4}] actionbar {"rawtext": [{"text": "Still immune to heat for: 3 seconds"}]}
titleraw @a[scores={heat_clemency=3}] actionbar {"rawtext": [{"text": "Still immune to heat for: 2 seconds"}]}
titleraw @a[scores={heat_clemency=2}] actionbar {"rawtext": [{"text": "Still immune to heat for: 1 seconds"}]}
titleraw @a[scores={cold_clemency=60}] actionbar {"rawtext": [{"text": "Still immune to cold for: "}, {"score":{"name": "*","objective": "cold_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={cold_clemency=45}] actionbar {"rawtext": [{"text": "Still immune to cold for: "}, {"score":{"name": "*","objective": "cold_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={cold_clemency=30}] actionbar {"rawtext": [{"text": "Still immune to cold for: "}, {"score":{"name": "*","objective": "cold_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={cold_clemency=10}] actionbar {"rawtext": [{"text": "Still immune to cold for: "}, {"score":{"name": "*","objective": "cold_clemency"}}, {"text": " seconds"}]}
titleraw @a[scores={cold_clemency=6}] actionbar {"rawtext": [{"text": "Still immune to cold for: 5 seconds"}]}
titleraw @a[scores={cold_clemency=5}] actionbar {"rawtext": [{"text": "Still immune to cold for: 4 seconds"}]}
titleraw @a[scores={cold_clemency=4}] actionbar {"rawtext": [{"text": "Still immune to cold for: 3 seconds"}]}
titleraw @a[scores={cold_clemency=3}] actionbar {"rawtext": [{"text": "Still immune to cold for: 2 seconds"}]}
titleraw @a[scores={cold_clemency=2}] actionbar {"rawtext": [{"text": "Still immune to cold for: 1 seconds"}]}

effect @a[scores={fire_resistance=2..}] fire_resistance 2
scoreboard players remove @a[scores={tick=20..,ice_resistance=2..}] ice_resistance 1
execute as @a[scores={tick=2..,ice_resistance=2..,thirsteffect=..1}] at @s positioned ~~~ run particle tl:ice_resistance_effect ~~0.3~
scoreboard players set @a[scores={ice_resistance=..1}] ice_resistance 1
scoreboard players remove @a[scores={tick=20..,fire_resistance=2..}] fire_resistance 1
scoreboard players set @a[scores={fire_resistance=..1}] fire_resistance 1
event entity @a tl:stop_ice_immune
event entity @a[scores={ice_resistance=2..}] tl:become_ice_immune

damage @a[m=!c,scores={tick=20..,temperature=..5,ice_resistance=..1,climate_clemency=..1,cold_clemency=..1,is_onfire=0}] 1 freezing
damage @a[m=!c,scores={tick=20..,temperature=27..,fire_resistance=..1,climate_clemency=..1,heat_clemency=..1,watercontact=..1}] 1 fire_tick
damage @a[m=!c,scores={tick=20..,parasiteseffect=2..}] 1 override
damage @a[m=!c,scores={tick=20..,thirst=..1}] 1 override
damage @a[m=!c,scores={tick=20..,stamina=..9}] 1 override

scoreboard players add @a current_rate 1
execute as @a run scoreboard players operation @s current_rate -= @s rate
execute as @a[scores={current_rate=0..}] run scoreboard players set @s current_rate 0
execute as @a[scores={current_rate=0..}] at @s run function TaB/temperature
execute as @a[scores={current_rate=..-1}] run scoreboard players operation @s current_rate += @s rate

scoreboard players set @a isinpowdersnow 1
execute as @a at @s if block ~~~ powder_snow -1 run scoreboard players set @s isinpowdersnow 2

execute as @a at @s run function TaB/thirst
execute as @a at @s run function TaB/armor_temp
execute as @a at @s run function TaB/rate
execute as @a at @s run function TaB/humidity
execute as @a at @s run function AW/seasons
execute as @a[scores={tick=20..}] at @s run function TaB/thermometer
execute as @a[scores={tick=20..,staminaenabled=2},m=!c] at @s run function TaB/stamina
scoreboard players remove @a[scores={tick=20..,targetcooldown=1..}] targetcooldown 1
execute as @a[scores={targetcooldown=..0}] at @s run function TaB/target
execute as @a[scores={tick=20..}] at @s run event entity @e[type=tl:player,r=1] tl:playerUpdate
effect @a[m=!c,scores={thirst=..7}] slowness 1 0 true
scoreboard players set @a[scores={temperature=..1}] temperature 1
scoreboard players set @a[scores={temperature=30..}] temperature 30


execute as @a[scores={sidebar=0}] run scoreboard objectives setdisplay sidebar started
execute as @a[scores={sidebar=1}] run scoreboard objectives setdisplay sidebar thirst
execute as @a[scores={sidebar=2}] run scoreboard objectives setdisplay sidebar thirsteffect
execute as @a[scores={sidebar=3}] run scoreboard objectives setdisplay sidebar temperature
execute as @a[scores={sidebar=4}] run scoreboard objectives setdisplay sidebar thirst
execute as @a[scores={sidebar=5}] run scoreboard objectives setdisplay sidebar thirst
execute as @a[scores={sidebar=6}] run scoreboard objectives setdisplay sidebar stamina
execute as @a[scores={sidebar=7}] run scoreboard objectives setdisplay sidebar thirst
execute as @a[scores={sidebar=8}] run scoreboard objectives setdisplay sidebar gamemode
execute as @a[scores={sidebar=9}] run scoreboard objectives setdisplay sidebar ice_resistance
execute as @a[scores={sidebar=10}] run scoreboard objectives setdisplay sidebar isinpowdersnow
execute as @a[scores={sidebar=11}] run scoreboard objectives setdisplay sidebar thirst
execute as @a[scores={sidebar=12}] run scoreboard objectives setdisplay sidebar parasiteseffect
execute as @a[scores={sidebar=13}] run scoreboard objectives setdisplay sidebar watercontact
execute as @a[scores={sidebar=14}] run scoreboard objectives setdisplay sidebar staminaenabled
execute as @a[scores={sidebar=15}] run scoreboard objectives setdisplay sidebar climate_clemency
execute as @a[scores={sidebar=16}] run scoreboard objectives setdisplay sidebar heat_clemency
execute as @a[scores={sidebar=17}] run scoreboard objectives setdisplay sidebar cold_clemency
execute as @r[c=1] run scoreboard players add world sidebar 1
scoreboard players operation @a sidebar = world sidebar
execute as @a[scores={sidebar=18..}] run scoreboard players set world sidebar 0

event entity @e[tag=used] tl:despawn
tag @e[tag=used] add kill
tag @a[hasitem={location=slot.weapon.mainhand,item=glass_bottle}] add holding_empty_bottle
tag @a[hasitem={location=slot.weapon.mainhand,item=tl:empty_canteen}] add holding_empty_canteen
tag @a[hasitem={location=slot.weapon.mainhand,item=tl:empty_iron_canteen}] add holding_empty_iron_canteen
tag @a[hasitem={location=slot.weapon.mainhand,item=tl:empty_gold_canteen}] add holding_empty_gold_canteen
tag @a[hasitem={location=slot.weapon.mainhand,item=tl:empty_diamond_canteen}] add holding_empty_diamond_canteen
tag @a[hasitem={location=slot.weapon.mainhand,item=tl:empty_netherite_canteen}] add holding_empty_netherite_canteen

execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run clear @p[r=5,tag=holding_empty_canteen,scores={refillRequest=1..}] tl:empty_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run replaceitem entity @p[r=5,tag=holding_empty_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run clear @p[r=5,tag=holding_empty_iron_canteen,scores={refillRequest=1..}] tl:empty_iron_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run replaceitem entity @p[r=5,tag=holding_empty_iron_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:iron_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run clear @p[r=5,tag=holding_empty_gold_canteen,scores={refillRequest=1..}] tl:empty_gold_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run replaceitem entity @p[r=5,tag=holding_empty_gold_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:purified_gold_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run clear @p[r=5,tag=holding_empty_diamond_canteen,scores={refillRequest=1..}] tl:empty_diamond_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run replaceitem entity @p[r=5,tag=holding_empty_diamond_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:diamond_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run clear @p[r=5,tag=holding_empty_netherite_canteen,scores={refillRequest=1..}] tl:empty_netherite_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run replaceitem entity @p[r=5,tag=holding_empty_netherite_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:purified_netherite_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run playsound bucket.fill_water @p[r=5,scores={refillRequest=1..}] ~~~
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run tag @s add used
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~-1~ tl:rain_collector_full 0 run tp @s ~~-1~
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run clear @p[r=5,tag=holding_empty_canteen] tl:empty_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run replaceitem entity @p[scores={gamemode=!2},r=5,tag=holding_empty_canteen] slot.weapon.mainhand 0 tl:canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run clear @p[r=5,tag=holding_empty_iron_canteen] tl:empty_iron_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run replaceitem entity @p[scores={gamemode=!2},r=5,tag=holding_empty_iron_canteen] slot.weapon.mainhand 0 tl:iron_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run clear @p[r=5,tag=holding_empty_gold_canteen] tl:empty_gold_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run replaceitem entity @p[scores={gamemode=!2},r=5,tag=holding_empty_gold_canteen] slot.weapon.mainhand 0 tl:purified_gold_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run clear @p[r=5,tag=holding_empty_diamond_canteen] tl:empty_diamond_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run replaceitem entity @p[scores={gamemode=!2},r=5,tag=holding_empty_diamond_canteen] slot.weapon.mainhand 0 tl:diamond_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run clear @p[r=5,tag=holding_empty_netherite_canteen] tl:empty_netherite_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run replaceitem entity @p[scores={gamemode=!2},r=5,tag=holding_empty_netherite_canteen] slot.weapon.mainhand 0 tl:purified_netherite_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run clear @p[r=5,tag=holding_empty_bottle] minecraft:glass_bottle 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run replaceitem entity @p[scores={gamemode=!2},r=5,tag=holding_empty_bottle] slot.weapon.mainhand 0 tl:water_bottle
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run scoreboard players add @p[r=5,tag=!holding_empty_canteen,tag=!holding_empty_iron_canteen,tag=!holding_empty_gold_canteen,tag=!holding_empty_diamond_canteen,tag=!holding_empty_netherite_canteen,tag=!holding_empty_bottle] thirst 12
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tl:rain_collector_full 0 run setblock ~~~ tl:rain_collector 0
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run clear @p[r=5,tag=holding_empty_canteen,scores={refillRequest=1..}] tl:empty_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run replaceitem entity @p[r=5,tag=holding_empty_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run clear @p[r=5,tag=holding_empty_iron_canteen,scores={refillRequest=1..}] tl:empty_iron_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run replaceitem entity @p[r=5,tag=holding_empty_iron_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:iron_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run clear @p[r=5,tag=holding_empty_gold_canteen,scores={refillRequest=1..}] tl:empty_gold_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run replaceitem entity @p[r=5,tag=holding_empty_gold_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:purified_gold_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run clear @p[r=5,tag=holding_empty_diamond_canteen,scores={refillRequest=1..}] tl:empty_diamond_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run replaceitem entity @p[r=5,tag=holding_empty_diamond_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:diamond_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run clear @p[r=5,tag=holding_empty_netherite_canteen,scores={refillRequest=1..}] tl:empty_netherite_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run replaceitem entity @p[r=5,tag=holding_empty_netherite_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:purified_netherite_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 0 run playsound bucket.fill_water @p[r=5,scores={gamemode=!2,refillRequest=1..}] ~~~
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 6 run setblock ~~~ cauldron 0
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 0 run tag @s add used
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run clear @p[r=5,tag=holding_empty_canteen,scores={refillRequest=1..}] tl:empty_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run replaceitem entity @p[r=5,tag=holding_empty_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run clear @p[r=5,tag=holding_empty_iron_canteen,scores={refillRequest=1..}] tl:empty_iron_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run replaceitem entity @p[r=5,tag=holding_empty_iron_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:iron_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run clear @p[r=5,tag=holding_empty_gold_canteen,scores={refillRequest=1..}] tl:empty_gold_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run replaceitem entity @p[r=5,tag=holding_empty_gold_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:purified_gold_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run clear @p[r=5,tag=holding_empty_diamond_canteen,scores={refillRequest=1..}] tl:empty_diamond_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run replaceitem entity @p[r=5,tag=holding_empty_diamond_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:diamond_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run clear @p[r=5,tag=holding_empty_netherite_canteen,scores={refillRequest=1..}] tl:empty_netherite_canteen 0 1
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run replaceitem entity @p[r=5,tag=holding_empty_netherite_canteen,scores={gamemode=!2,refillRequest=1..}] slot.weapon.mainhand 0 tl:purified_netherite_canteen
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 0 run playsound bucket.fill_water @p[r=5,scores={gamemode=!2,refillRequest=1..}] ~~~
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 7 run setblock ~~~ cauldron 0
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ cauldron 0 run tag @s add used
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ air -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ water -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ flowing_water -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ tallgrass -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ vine -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ acacia_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ birch_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ crimson_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ darkoak_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ jungle_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ mangrove_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ spruce_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ warped_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ acacia_wall_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ birch_wall_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ crimson_wall_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ darkoak_wall_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ jungle_wall_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ mangrove_wall_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ wall_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ spruce_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ warped_standing_sign -1 run tag @s add fly
execute as @e[type=tl:fill_canteen,tag=!used] at @s if block ~~~ kelp -1 run tag @s add fly
tag @e[type=tl:fill_canteen,tag=!fly] add used

execute as @e[scores={drinkPunch=1,tick=1,is_sneaking=1}] at @s positioned ^^0.5^1 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=1,is_sneaking=1}] at @s if block ^^0.5^1 air positioned ^^0.5^2 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=1,is_sneaking=1}] at @s if block ^^0.5^1 water positioned ^^0.5^2 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=1,is_sneaking=1}] at @s if block ^^0.5^1 flowing_water positioned ^^0.5^2 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=7,is_sneaking=1}] at @s positioned ^^0.5^1 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=7,is_sneaking=1}] at @s if block ^^0.5^1 air positioned ^^0.5^2 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=7,is_sneaking=1}] at @s if block ^^0.5^1 water positioned ^^0.5^2 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=7,is_sneaking=1}] at @s if block ^^0.5^1 flowing_water positioned ^^0.5^2 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=14,is_sneaking=1}] at @s positioned ^^0.5^1 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=14,is_sneaking=1}] at @s if block ^^0.5^1 air positioned ^^0.5^2 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=14,is_sneaking=1}] at @s if block ^^0.5^1 water positioned ^^0.5^2 run summon tl:drink
execute as @e[scores={drinkPunch=1,tick=14,is_sneaking=1}] at @s if block ^^0.5^1 flowing_water positioned ^^0.5^2 run summon tl:drink
execute as @e[type=tl:drink,tag=!used] at @s if block ~~~ water -1 run scoreboard players set @p handDrinkRequest 8
execute as @e[type=tl:drink,tag=!used] at @s if block ~~~ water -1 run tag @s add used
scoreboard players set @e[scores={drinkPunch=1,tick=1,is_lookingup=1,is_sneaking=1,is_underrain=1}] handDrinkRequest 8
scoreboard players set @e[scores={drinkPunch=1,tick=7,is_lookingup=1,is_sneaking=1,is_underrain=1}] handDrinkRequest 8
scoreboard players set @e[scores={drinkPunch=1,tick=14,is_lookingup=1,is_sneaking=1,is_underrain=1}] handDrinkRequest 8

execute as @e[scores={handDrinkRequest=8},type=player] at @s positioned ^^^0.1 positioned ~~0.3~ run summon tl:isattacking
#execute as @e[type=tl:isattacking,scores={handDrinkRequest=1..},c=2] at @s run tag @s add hitbox
#execute as @e[type=tl:isattacking,tag=hitbox] run event entity @e[type=tl:isattacking,tag=!hitbox,r=1] tl:despawn
#execute as @e[scores={handDrinkRequest=8},type=player] run scoreboard players set @e[type=tl:isattacking,r=1] handDrinkRequest 8
#event entity @e[type=tl:isattacking,scores={handDrinkRequest=..0}] tl:despawn

execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ dirt -1 run replaceitem entity @p[r=5,scores={gamemode=!2,mudRequest=1..}] slot.weapon.mainhand 0 glass_bottle
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ dirt -1 run playsound block.mud.place @p[r=5,scores={gamemode=!2,mudRequest=1..}]
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ dirt -1 run setblock ~~~ mud 0
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ mud -1 run tag @s add used
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ air -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ water -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ flowing_water -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ tallgrass -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ vine -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ acacia_standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ birch_standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ crimson_standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ darkoak_standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ jungle_standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ mangrove_standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ spruce_standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ warped_standing_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ acacia_wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ birch_wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ crimson_wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ darkoak_wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ jungle_wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ mangrove_wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ spruce_wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ warped_wall_sign -1 run tag @s add fly
execute as @e[type=tl:mud,tag=!used] at @s if block ~~~ kelp -1 run tag @s add fly
tag @e[type=tl:mud,tag=!fly] add used
tag @e remove fly
tag @a remove holding_empty_bottle
tag @a remove holding_empty_canteen
tag @a remove holding_empty_iron_canteen
tag @a remove holding_empty_gold_canteen
tag @a remove holding_empty_diamond_canteen
tag @a remove holding_empty_netherite_canteen
scoreboard players remove @a handDrinkRequest 1
scoreboard players set @a[scores={handDrinkRequest=..0}] handDrinkRequest 0
scoreboard players remove @a refillRequest 1
scoreboard players set @a[scores={refillRequest=..0}] refillRequest 0
scoreboard players remove @a mudRequest 1
scoreboard players set @a[scores={mudRequest=..0}] mudRequest 0

execute as @e[type=tl:rain_collector,scores={rain_collector=2..}] run event entity @e[type=tl:rain_collector,scores={rain_collector=..1},r=1] tl:despawn
execute as @e[type=tl:rain_collector] run tag @s add kill
execute as @e[type=tl:rain_collector] at @s if block ~~-1~ tl:rain_collector 0 run tag @s remove kill
execute as @e[type=tl:rain_collector] at @s if block ~~-1~ tl:rain_collector_half 0 run tag @s remove kill
execute as @e[type=tl:rain_collector] at @s if block ~~-1~ tl:rain_collector_almost 0 run tag @s remove kill
execute as @e[type=tl:rain_collector,scores={is_underrain=0}] run tag @s add kill
execute as @a[scores={tick=20..}] as @e[type=tl:rain_collector,scores={is_underrain=1}] run scoreboard players add @s rain_collector 1
execute as @e[scores={rain_collector=20..},type=tl:rain_collector] at @s if block ~~-1~ tl:rain_collector 0 run setblock ~~-1~ tl:rain_collector_half
execute as @e[scores={rain_collector=40..},type=tl:rain_collector] at @s if block ~~-1~ tl:rain_collector_half 0 run setblock ~~-1~ tl:rain_collector_almost
execute as @e[scores={rain_collector=60..},type=tl:rain_collector] at @s if block ~~-1~ tl:rain_collector_almost 0 run setblock ~~-1~ tl:rain_collector_full

execute as @e[type=tl:water_purifier,tag=!init] run scoreboard players set @s progress 0
execute as @e[type=tl:water_purifier,tag=!init] run scoreboard players set @s fuel 0
execute as @e[type=tl:water_purifier,tag=!init] run tag @s add init
execute as @e[type=tl:water_purifier] at @s run tp @s ~~~
execute as @e[type=tl:water_purifier,scores={progress=2..}] at @s run tp @e[type=tl:water_purifier,scores={progress=..1},r=1] ~ -1000 ~
execute as @e[type=tl:water_purifier] run tag @s add kill
execute as @e[type=tl:water_purifier] at @s if block ~~~ tl:water_purifier 0 run tag @s remove kill
execute as @e[type=tl:water_purifier] at @s if block ~~-1~ tl:water_purifier 0 run tag @s remove kill
tag @e[type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:water_bottle}] add hasingredient
tag @e[type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=potion,data=0}] add hasingredient
tag @e[type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:canteen}] add hasingredient
tag @e[type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:iron_canteen}] add hasingredient
tag @e[type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:diamond_canteen}] add hasingredient
execute as @e[type=tl:water_purifier] run scoreboard players add @s progress 1
execute as @e[type=tl:water_purifier,scores={fuel=..0,progress=2..}] run scoreboard players set @s progress 2
execute as @e[type=tl:water_purifier,scores={progress=2..},tag=!hasingredient] run scoreboard players set @s progress 2
execute as @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:water_bottle}] at @s run function TaB/give_purified_bottle
execute as @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=potion,data=0}] at @s run function TaB/give_purified_bottle
execute as @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:canteen}] at @s run function TaB/give_purified_canteen
execute as @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:iron_canteen}] at @s run function TaB/give_purified_iron_canteen
execute as @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:diamond_canteen}] at @s run function TaB/give_purified_diamond_canteen
execute as @a[scores={tick=20..}] as @e[type=tl:water_purifier,tag=hasingredient] at @s run function TaB/purifier_fuel
replaceitem entity @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:water_bottle}] slot.inventory 0 air
replaceitem entity @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=potion,data=0}] slot.inventory 0 air
replaceitem entity @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:canteen}] slot.inventory 0 air
replaceitem entity @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:iron_canteen}] slot.inventory 0 air
replaceitem entity @e[scores={progress=300..},type=tl:water_purifier,hasitem={location=slot.inventory,slot=0,item=tl:diamond_canteen}] slot.inventory 0 air
execute as @e[scores={progress=300..},type=tl:water_purifier] run scoreboard players set @s progress 2
tag @e[type=tl:water_purifier] remove hasingredient

execute as @e[type=tl:redstone_detector,tag=!used] at @s run function TaB/redstone_detector
execute as @e[type=tl:redstone_detector,tag=!powered] at @s if block ~~~ tl:cooling_coil run setblock ~~~ tl:cooling_coil_off
execute as @e[type=tl:redstone_detector,tag=powered] at @s if block ~~~ tl:cooling_coil_off run setblock ~~~ tl:cooling_coil
execute as @e[type=tl:redstone_detector,tag=!powered] at @s if block ~~~ tl:heating_coil run setblock ~~~ tl:heating_coil_off
execute as @e[type=tl:redstone_detector,tag=powered] at @s if block ~~~ tl:heating_coil_off run setblock ~~~ tl:heating_coil

scoreboard players set @s[scores={watercontact=..2,is_underrain=0}] watercontact 1
scoreboard players set @s[scores={watercontact=..2,is_underrain=1}] watercontact 2

scoreboard players set @a[scores={parasitesRandom=2}] parasiteseffect 30
scoreboard players set @a parasitesRandom 0

scoreboard players set @a[m=s] gamemode 1
scoreboard players set @a[m=c] gamemode 2
scoreboard players set @a[m=a] gamemode 3

tag @e[tag=killed] remove kill
tag @e[tag=!kill] remove killed
tag @e[tag=kill] add killed
tp @e[tag=kill] ~ -1000 ~
event entity @e[tag=kill] tl:despawn
kill @e[tag=kill]

scoreboard players set world worldentities 0
execute as @e[type=tl:world] run scoreboard players add world worldentities 1
scoreboard players operation @a worldentities = world worldsafe

#DEBUG
titleraw @a[tag=debugworld] title {"rawtext": [{"text": "World entities count: "}, {"score":{"name": "*","objective": "worldentities"}}]}
titleraw @a[tag=debugworld] subtitle {"rawtext": [{"text": "World safe entities count: "}, {"score":{"name": "*","objective": "worldsafe"}}]}
titleraw @a[tag=debugdrinkpunch] title {"rawtext": [{"text": "Drink request: "}, {"score":{"name": "*","objective": "handDrinkRequest"}}]}
titleraw @a[tag=debugdrinkpunch] subtitle {"rawtext": [{"text": "Drink punch: "}, {"score":{"name": "*","objective": "drinkPunch"}}]}
titleraw @a[tag=debugblocks] title {"rawtext": [{"text": "heat_blocks: "}, {"score":{"name": "*","objective": "heat_blocks"}}, {"text": " cold_blocks: "}, {"score":{"name": "*","objective": "cold_blocks"}}, {"text": " water_blocks: "}, {"score":{"name": "*","objective": "water_blocks"}}]}
titleraw @a[tag=debugblocks] subtitle {"rawtext": [{"text": "heat_blocks: "}, {"score":{"name": "*","objective": "heat_blocks"}}, {"text": "soul_fire_blocks: "}, {"score":{"name": "*","objective": "soul_fire_blocks"}}]}
titleraw @a[tag=debugtemp] title {"rawtext": [{"text": "Rate: "}, {"score":{"name": "*","objective": "current_rate"}}, {"text": "/"}, {"score":{"name": "*","objective": "rate"}}]}
titleraw @a[tag=debugtemp] subtitle {"rawtext": [{"text": "Temperature: "}, {"score":{"name": "*","objective": "temperature"}}, {"text": "/"}, {"score":{"name": "*","objective": "target"}}, {"text": " Humidity: "}, {"score":{"name": "*","objective": "humidity"}}]}
titleraw @a[tag=debugstamina] title {"rawtext": [{"text": "Stamina: "}, {"score":{"name": "*","objective": "stamina"}}]}
titleraw @a[tag=debugthirst] title {"rawtext": [{"text": "Thirst: "}, {"score":{"name": "*","objective": "thirst"}}]}
titleraw @a[tag=debugthirst] subtitle {"rawtext": [{"text": "Thirst Saturation: "}, {"score":{"name": "*","objective": "thirstSaturation"}}, {"text": " / Thirst Exhaustion: "}, {"score":{"name": "*","objective": "thirstExhaustion"}}, {"text": " / Thirst Effect: "}, {"score":{"name": "*","objective": "thirsteffect"}}]}

#Enable sending feedback to users
gamerule showdeathmessages true
gamerule sendcommandfeedback true
